# TPK4186 - Advanced Tools for Performance Engineering
# Factorial.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Recursive version
def FactorialRecursive(n):
  if n==0:
    return 1
  if n==1:
    return 1
  return n*FactorialRecursive(n-1)

print("20! = " + str(FactorialRecursive(20)))

# Version with a while loop
def FactorialWhileLoop(n):
  product = 1
  i = 2
  while i<=n:
    product = product*i
    i = i+1
  return product

print("20! = " + str(FactorialWhileLoop(20)))


# Version with a for loop
def FactorialForLoop(n):
  product = 1
  for i in range(2, n+1):
    product = product*i
  return product

print("20! = " + str(FactorialForLoop(20)))
