# TPK4186 - Advanced Tools for Performance Engineering
# Palindrome.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def Palindrome(string):
  normalizedString = string.lower()
  l = 0
  h = len(normalizedString)-1
  while l<h:
    if not normalizedString[l].isalpha():
      l += 1
      continue
    if not normalizedString[h].isalpha():
      h -= 1
      continue
    if normalizedString[l]!=normalizedString[h]:
      return False
    l += 1
    h -= 1
  return True

print(str(Palindrome("A man, a plan, a canal, Panama!")))

