# TPK4186 - Advanced Tools for Performance Engineering
# CountParentheses.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

text = "((((3*2)+6)-1)/7))(8+2)/4))))"
i = 0
numberOfLeftParentheses = 0
numberOfRightParentheses = 0
firstUnbalancedPosition = -1
numberOfUnbalancedPositions = 0
while i<len(text):
  if text[i]=='(':
    numberOfLeftParentheses += 1
  elif text[i]==')':
    numberOfRightParentheses += 1
  if numberOfLeftParentheses<numberOfRightParentheses:
    numberOfUnbalancedPositions += 1
    if firstUnbalancedPosition==-1:
      firstUnbalancedPosition = i
  i += 1
print("Number of left parentheses\t" + str(numberOfLeftParentheses))
print("Number of right parentheses\t" + str(numberOfRightParentheses))
print("Number of unbalanced positions\t" + str(numberOfUnbalancedPositions))
if numberOfUnbalancedPositions>0:
  print("First unbalanced positions\t" + str(firstUnbalancedPosition))
