# TPK4186 - Advanced Tools for Performance Engineering
# GridWalk.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def GridWalk(numberOfRows, numberOfColumns):
  x = 0
  y = 0
  dy = 1
  while x<numberOfRows:
    print(str(x) + "\t" + str(y))
    if dy==1:
      if y<numberOfColumns-1:
        y += 1
      else:
        x += 1
        dy = -1
    else:
      if y>0:
        y -= 1
      else:
        x += 1
        dy = 1

GridWalk(5, 5)

